stages:
  - test
  - build
  - deploy
  - tag


test:
  stage: test
  image: python:3.9
  script:
    - pwd  # Debugging: print the working directory
    - ls -la  # Debugging: list what's in the directory
    # - python -m venv venv
    # - source venv/bin/activate
    - openssl aes-256-cbc -d -in secrets.json.enc -out secrets.json -pass pass:$SECRETS_KEY
    - pip install --upgrade pip
    - pip install -r requirements-dev.txt  # Install both production and development dependencies
    - export FBN_SECRETS_PATH="$(pwd)/secrets.json"
    - pip install -e . --no-deps  # Install the package in editable mode
    - python -m pytest tests/ --junitxml=report.xml
  artifacts:
    reports:
      junit: report.xml
  only:
    - master

build_package:
  stage: build
  image: python:3.9
  script:
    - pip install setuptools wheel
    - pip install -r requirements-dev.txt
    - python scripts/generate_apis.py
    - python setup.py sdist bdist_wheel
  artifacts:
    paths:
      - dist/*
  only:
    - master  # Run this job only on pushes to master

deploy:
  stage: deploy
  image: python:latest
  script:
    - pip install twine
    - twine upload --config-file $PYPIRC_FILE dist/*
  only:
    - master

create_tag:
  stage: tag
  script:
    - 'curl --header "PRIVATE-TOKEN: $GITLAB_TOKEN" "https://gitlab.com/api/v4/projects/$CI_PROJECT_ID/repository/tags?tag_name=v$(date +%Y.%m.%d.%H%M%S)&ref=$CI_COMMIT_SHA"'
  only:
    - master
